﻿
-- Garrison Done --
-- Written by Jaxom of Hellfire --
-- All rights Reserved --

GarrisonDone_Version = GetAddOnMetadata("GarrisonDone", "Version")

-- DEFAULTS --
 
local self = GarrisonDone;  

-- ON LOAD --

function GarrisonDone_OnLoad()
 
        -- START --
   
        -- FIX FRAME SIZE SETTINGS --
        
        GarrisonDone_Frame:SetMinResize(195,240);
        GarrisonDone_Frame:SetMaxResize(195,240);
        
        -- REGISTER EVENTS --
        
        GarrisonDone:RegisterEvent("VARIABLES_LOADED");
        GarrisonDone_Frame:RegisterEvent("STORETEXT");
        GarrisonDone_Frame:RegisterEvent("ONTEXTCHANGED");
        GarrisonDone_Frame:RegisterEvent("UPDATE");
        GarrisonDone_Frame:RegisterEvent("GETTEXT");
        GarrisonDone_Frame:RegisterEvent("SETTEXT");
        GarrisonDone_Frame:RegisterEvent("ONFOCUS");
        GarrisonDone_Frame:RegisterEvent("SETFOCUS");
        GarrisonDone_Frame:RegisterEvent("CLEARFOCUS");
        GarrisonDone_Frame:RegisterEvent("ONSHOW");
        GarrisonDone_Frame:RegisterEvent("ONHIDE");
        GarrisonDone_Frame:RegisterEvent("ONCLICK");
        GarrisonDone_Frame:RegisterEvent("REGISTERFORDRAG");
        
	    table.insert(UISpecialFrames,"GarrisonDone_Frame");    
               
        -- SLASH COMMANDS --
        
        SlashCmdList["GARRISONDONE"] = function(sMsg)
			GarrisonDone_Slash_Command(sMsg)
		end
		SLASH_GARRISONDONE1 = "/mgd";
end
        


function GarrisonDone_Loaded()
    if GarrisonDone_Varsc == nil then
        GarrisonDone_Varsc = GarrisonDone_Defaults
        DEFAULT_CHAT_FRAME:AddMessage("My Garrison is Done database not found. Generating Defaults...");
        end
    if (GarrisonDone_Varsc["version"] < GarrisonDone_Version) then
        GarrisonDone_Varsc_temp = GarrisonDone_Defaults;
        for k,v in GarrisonDone_Varsc do
    if (GarrisonDone_Defaults["Vars"][k]) then
        GarrisonDone_Varsc_temp[k] = v;
     end
  end
        GarrisonDone_Varsc_temp["version"] = GarrisonDone_Version;
        GarrisonDone_Varsc = GarrisonDone_Varsc_temp;
    end
end

-- Load Minimap lib --

local icon = LibStub:GetLibrary("LibDBIcon-1.0")

-- Function - Load Variables and fire it up :) --

function GarrisonDone_OnEvent(event, self, ...)
        if event == "VARIABLES_LOADED" then
            
  -- Set the Saved Variable states --
  
	--	GarrisonDone_Varsc. = tostring(GarrisonDone_Varsc.); -- new variables here  --
	--	if GarrisonDone_Varsc. == "nil" then
	--		GarrisonDone_Varsc. = "";
	--	end
    
  -- Set the we hope correct variables for LibDBIcon --
  
    	GarrisonDone_Varsc.db.profile = table.contains(GarrisonDone_Varsc.db.profile); -- new variables here  --
		if GarrisonDone_Varsc.db.profile == "nil" then
			GarrisonDone_Varsc.db.profile = {
			minimap = {
				hide = false,
			},
		},
        -- Register minimap icon and set update command --
        icon:Register("GarrisonDone", gdldb, GarrsionDone_Varsc.db.profile.minimap)
	    -- self:RegisterChatCommand("GarrisonDone", "Update_Minimap") -- Not sure need this took it from LibDBIcon
        
  -- Set Table to look for Herbs and Ore --  
		
        if(not table.contains) then
	function table.contains(table, element)
  		for _, value in pairs(table) do
	    	if value == element then
	      		return true
	    	end
	  	end

	  	return false
	end
end
        
        GarrisonDone_Update_Minimap();
        GarrisonDone_Loaded();
        GarrisonDone_SetText();
        
        
    end 
end

-- Insert req calls and hooks to get information to put in frame --

function GarrisonDone_Update(Self)
    
end

-- Build Frame in LUA using Game Menu as Inherit --

local GarrisonDone_Frame = CreateFrame("Frame", "GarrisonDone", GameMenuFrame, UIParent)
        GarrisonDone_Frame:SetPoint("Left",0,0)
        GarrisonDone_Frame:SetWidth(195)
        GarrisonDone_Frame:SetHeight(240)
    
        mgdFrame_EditBox = CreateFrame("EditBox", "GarrisonDone_FrameEditBox", garrisondone)
        mgdFrame_EditBox:SetPoint ("TOPLEFT",26,-42)
	    mgdFrame_EditBox:EnableMouse(false)
	    mgdFrame_EditBox:SetAutoFocus(false)
	    mgdFrame_EditBox:SetFontObject(GameFontNormal)
	    mgdFrame_EditBox:SetWidth(185)
	    mgdFrame_EditBox:SetHeight(230)
        mgdFrame_EditBox:SetText("")
	    mgdFrame_EditBox:Show()
    
        mgdEditBoxText = mgdFrame_EditBox:CreateFontString("GarrisonDone_FrameEditBoxTitle", "ARTWORK", "GameFontHighlight")
	    mgdEditBoxText:SetPoint("BOTTOMLEFT", mgdFrame_EditBox, 5, -5)
	    mgdEditBoxText:SetWidth(185)
	    mgdEditBoxText:SetHeight(50)
        mgdEditBoxText:SetFontObject(GameFontHighlight)
        mgdEditBoxText:SetJustifyH("LEFT")
	    mgdEditBoxText:SetText("My Garrison is Done test string "..GarrisonDone_Version.."")
        
        mgdEditBoxText1 = mgdFrame_EditBox:CreateFontString("GarrisonDone_FrameEditBoxTitle", "ARTWORK", "GameFontHighlight")
	    mgdEditBoxText1:SetPoint("BOTTOMLEFT", mgdFrame_EditBox, 5, -5)
	    mgdEditBoxText1:SetWidth(185)
	    mgdEditBoxText1:SetHeight(50)
        mgdEditBoxText1:SetFontObject(GameFontHighlight)
        mgdEditBoxText1:SetJustifyH("LEFT")
	    mgdEditBoxText1:SetText("Missions Completed "..GarrisonDone_Version.."")
        
        mgdEditBoxText2 = mgdFrame_EditBox:CreateFontString("GarrisonDone_FrameEditBoxTitle", "ARTWORK", "GameFontHighlight")
	    mgdEditBoxText2:SetPoint("BOTTOMLEFT", mgdFrame_EditBox1, 5, -5)
	    mgdEditBoxText2:SetWidth(185)
	    mgdEditBoxText2:SetHeight(50)
        mgdEditBoxText2:SetFontObject(GameFontHighlight)
        mgdEditBoxText2:SetJustifyH("LEFT")
	    mgdEditBoxText2:SetText("Missions Available "..GarrisonDone_Version.."")
        
        mgdEditBoxText3 = mgdFrame_EditBox:CreateFontString("GarrisonDone_FrameEditBoxTitle", "ARTWORK", "GameFontHighlight")
	    mgdEditBoxText3:SetPoint("BOTTOMLEFT", mgdFrame_EditBox2, 5, -5)
	    mgdEditBoxText3:SetWidth(185)
	    mgdEditBoxText3:SetHeight(50)
        mgdEditBoxText3:SetFontObject(GameFontHighlight)
        mgdEditBoxText3:SetJustifyH("LEFT")
	    mgdEditBoxText3:SetText("Followers Available "..GarrisonDone_Version.."")
        
        mgdEditBoxText4 = mgdFrame_EditBox:CreateFontString("GarrisonDone_FrameEditBoxTitle", "ARTWORK", "GameFontHighlight")
	    mgdEditBoxText4:SetPoint("BOTTOMLEFT", mgdFrame_EditBox3, 5, -5)
	    mgdEditBoxText4:SetWidth(185)
	    mgdEditBoxText4:SetHeight(50)
        mgdEditBoxText4:SetFontObject(GameFontHighlight)
        mgdEditBoxText4:SetJustifyH("LEFT")
	    mgdEditBoxText4:SetText("Followers on Mission "..GarrisonDone_Version.."")
        
        mgdEditBoxText5 = mgdFrame_EditBox:CreateFontString("GarrisonDone_FrameEditBoxTitle", "ARTWORK", "GameFontHighlight")
	    mgdEditBoxText5:SetPoint("BOTTOMLEFT", mgdFrame_EditBox4, 5, -5)
	    mgdEditBoxText5:SetWidth(185)
	    mgdEditBoxText5:SetHeight(50)
        mgdEditBoxText5:SetFontObject(GameFontHighlight)
        mgdEditBoxText5:SetJustifyH("LEFT")
	    mgdEditBoxText5:SetText("Followers Working "..GarrisonDone_Version.."")
        
        mgdEditBoxText6 = mgdFrame_EditBox:CreateFontString("GarrisonDone_FrameEditBoxTitle", "ARTWORK", "GameFontHighlight")
	    mgdEditBoxText6:SetPoint("BOTTOMLEFT", mgdFrame_EditBox5, 5, -5)
	    mgdEditBoxText6:SetWidth(185)
	    mgdEditBoxText6:SetHeight(50)
        mgdEditBoxText6:SetFontObject(GameFontHighlight)
        mgdEditBoxText6:SetJustifyH("LEFT")
	    mgdEditBoxText6:SetText("Mining Nodes = "..GarrisonDone_Version.."")
        
        mgdEditBoxText7 = mgdFrame_EditBox:CreateFontString("GarrisonDone_FrameEditBoxTitle", "ARTWORK", "GameFontHighlight")
	    mgdEditBoxText7:SetPoint("BOTTOMLEFT", mgdFrame_EditBox6, 5, -5)
	    mgdEditBoxText7:SetWidth(185)
	    mgdEditBoxText7:SetHeight(50)
        mgdEditBoxText7:SetFontObject(GameFontHighlight)
        mgdEditBoxText7:SetJustifyH("LEFT")
	    mgdEditBoxText7:SetText("Herb Nodes =  "..GarrisonDone_Version.."")
    

-- Get Garrison Map Id's, so we know were the Garrison is --

local garrisonMapIds = { 1152, 1330, 1153, 1154, 1158, 1331, 1159, 1160 }

-- Function - Is the Player in there Garrison, if there not we dont want to show --

function IsInGarrison()
	local _, _, _, _, _, _, _, mapId = GetInstanceInfo()

	return table.contains(garrisonMapIds, mapId)
    end
    
    if zone == GetCurrentMapZone("Lunarfall") then
        GarrisonDone_Frame:Show()
        elseif zone ~= GetCurrentMapZone("Lunarfall") then
        GarrisonDone_Frame:Hide()        
    end 
end
 --   if GarrisonDone_Frame:Show() == true then -- Ready for saved variable to be added --
--        GarrisonDone_Frame:Show();
--    else
--        GarrisonDone_Frame:Hide();
-- end

function GarrisonDone_Update_Minimap()
	GarrisonDone_Varsc.db.profile.minimap.hide = not GarrisonDone_Varsc.db.profile.minimap.hide
	if GarrisonDone_Varsc.db.profile.minimap.hide then
		icon:Hide("GarrisonDone")
	else
		icon:Show("GarrisonDone")
	end
end




-- Garrison Done Frame (based on logout xml ;) ) --

    -- SHOW FRAME --    
function  GarrisonDone_Frame_OnShow(self)
    GarrisonDone_Frame:Show();
    GarrisonDone_Update();
    GarrisonDone_SetText();
end

    -- TOGGLES FRAME USEING SLASH COMMAND --
function GarrisonDone_Slash_Command(sMsg)
	if GarrisonDone_Frame:IsVisible() then
		GarrisonDone_Frame:Hide();
	else
		GarrisonDone_Frame:Show();
	end
end

    -- MOVES FRAME --
function  GarrisonDone_Frame_OnMouseDown(self)
    if Button == "RightButton" then
	    GarrisonDoneFrame:StartMoving();
    end
end

function  GarrisonDone_Frame_OnMouseUp(self)
	if Button == "RightButton" then
	GarrisonDoneFrame:StopMovingOrSizing();
	end
end

-- REMOVES FRAME IF DISABLE TRUE --
function  GarrisonDone_Frame_MakeESCable(frame,disable)
	local idx
	for i=1,#(UISpecialFrames) do
		if UISpecialFrames[i]==frame then
			idx = i
			break
		end
	end
	if idx and disable then
		table.remove(UISpecialFrames,idx)
	elseif not idx and not disable then
		table.insert(UISpecialFrames,1,frame)
	end
end




-- TEXT FUNCTIONS - this is were we get all the answers and insert into box, I hope --


function GarrisonDone_Update()
	-- set current page name & contents --
    
	if (GarrisonDone_Frame:IsShown()) then
		GarrisonDonePageName:SetText("My Garrison is Done - "..GarrisonDone_Version.." ");
     --   GarrisonDone_Frame_EditFrame:set child; -- need to set child but were not using a scroll frame
        end
        
        -- add contents here --
end

function GarrisonDone_SetText()
-- we need to set text from update on changes to missions, followers and elements --
end

function GarrisonDone_StoreText(playSoundFx)
	-- SAVE  TO STORED VAR --
    -- We want to save certain variables but which ones --
	-- GarrisonDone_Varsc. = GarrisonDone_Frame:GetText(stuff for later);
	-- GarrisonDone_Vars. = GarrisonDone_Frame:GetText(); -- 
    DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Your Garrison has Been Updated") 
	
	PlaySound("WriteQuest");
	
end




 -- LDB LAUNCHER  --
 
 --Local-- NOTE: Probably dont need half of these!
    
    local GarrisonDone_Varsc = GarrisonDone_Varsc
    local mgdldb = LibStub:GetLibrary("LibDataBroker-1.1")
    
    
local mgdldb = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("GarrisonDone", {
            type = "launcher",
	        text = "My Garrison is Done",
            label = "My Garrison is Done",
            tocname = "GarrisonDone",
            icon = "Interface\\AddOns\\GarrisonDone\\images\\MGDL.tga",
            OnClick = function(self, button)
        if (button == "LeftButton") then
           if GarrisonDone_Frame:IsVisible() then
		        GarrisonDone_Frame:Hide()
	        else
		        GarrisonDone_Frame:Show()
	    end
       	elseif (button == "RightButton") then
		    InterfaceOptionsFrame_OpenToCategory("GarrisonDone") 
            end
        end,
            OnTooltipShow = function(tooltip)
                tooltip:AddLine('My Garrison is Done')
                tooltip:AddLine('|cffffff00Left click for My Garrison Panel')
                tooltip:AddLine('|cffffff00Right Click for Interface Panel')
            end,
        })
    


   -- INTERFACE OPTIONS MENU -- 
    
   -- FRAME 1 --
  
    
	local garrisondone = CreateFrame("Frame", "GarrisonDone", UIParent)
	garrisondone:Hide()
    garrisondone:IsResizable(true)
    garrisondone:SetMinResize(350,250)
	garrisondone.name = "My Garrison is Done"
    garrisondone:SetBackdropColor(0, 0, 0, 1)
	garrisondone:SetWidth(250)
	garrisondone:SetHeight(400)
	garrisondone:SetPoint("CENTER", UIParent, "CENTER")
	InterfaceOptions_AddCategory(garrisondone)

	local title = garrisondone:CreateFontString("GarrisonDoneTitle", "ARTWORK", "GameFontNormalLarge")
	title:SetPoint("TOPLEFT", 16, -20)
	title:SetText("My Garrison is Done ("..GarrisonDone_Version..")" )
 
    
    local mgdEditBox = CreateFrame("EditBox", "GarrisonDoneEditBox", garrisondone)
    mgdEditBox:SetPoint ("TOPLEFT",26,-42)
	mgdEditBox:EnableMouse(false)
	mgdEditBox:SetAutoFocus(false)
	mgdEditBox:SetFontObject(GameFontNormal)
	mgdEditBox:SetWidth(450)
	mgdEditBox:SetHeight(120)
    mgdEditBox:SetText("")
	mgdEditBox:Show()
    
    local mgdEditBoxText = mgdEditBox:CreateFontString("GarrisonDoneEditBoxTitle", "ARTWORK", "GameFontHighlight")
	mgdEditBoxText:SetPoint("BOTTOMLEFT", mgdEditBox, 5, -5)
	mgdEditBoxText:SetWidth(420)
	mgdEditBoxText:SetHeight(110)
    mgdEditBoxText:SetFontObject(GameFontHighlight)
    mgdEditBoxText:SetJustifyH("LEFT")
	mgdEditBoxText:SetText("Garrison Done")
    
    local mgdEditBoxText2 = mgdEditBox:CreateFontString("GarrisonDoneEditBoxTitle", "ARTWORK", "GameFontHighlight")
	mgdEditBoxText2:SetPoint("BOTTOMLEFT", mgdEditBox, 5, -115)
	mgdEditBoxText2:SetWidth(420)
	mgdEditBoxText2:SetHeight(110)
    mgdEditBoxText2:SetFontObject(GameFontHighlight)
    mgdEditBoxText2:SetJustifyH("LEFT")
	mgdEditBoxText2:SetText(" xml. |cff007fffJaxom of Hellfire EU")
      

     -- OPTIONS TITLE --
    
    local mgdtitle = garrisondone:CreateFontString("GarrisonDoneTitle", "ARTWORK", "GameFontHighlightLarge")
	mgdtitle:SetPoint("TOPLEFT", 16, -287)
	mgdtitle:SetText("|cff007fffOptions")       
                    
    -- HIDE MINIMAP BUTTON --
    
    local mgdmini = CreateFrame("CheckButton", "GarrisonDoneButton1", garrisondone)
	mgdmini:SetWidth(26)
	mgdmini:SetHeight(26)
	mgdmini:SetPoint("TOPLEFT", 16, -317)
--    gdmini:SetChecked(GarrisonDone_Vars.db.profile.minimap.hide == false)
    mgdmini:SetScript("OnClick", function(self)
            if self:GetChecked() then
    --        GarrisonDone_Vars.db.profile.minimap.hide = false
            icon:Show("GarrisonDone")
            DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[Garrison Done] - |cff007fffMinimap Button is now ON");
            else
     --       GarrisonDone_Vars.db.profile.minimap.hide = true
            icon:Hide("GarrisonDone")
            DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[Garrison Done] - |cff007fffMinimap Button is now OFF");
            end
	end--function
    )
    
   
	mgdmini:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up")
	mgdmini:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down")
	mgdmini:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight")
	mgdmini:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check")

	local mgdminiText = mgdmini:CreateFontString("GarrisonDoneButton1Title", "ARTWORK", "GameFontHighlight")
	mgdminiText:SetPoint("LEFT", mgdmini, "RIGHT", 0, 2)
	mgdminiText:SetText("|CFF00AA00Hide Minimap Button|r")
    
    local mgdminiText2 = mgdmini:CreateFontString("GarrisonDoneButton1Title", "ARTWORK", "GameFontHighlightSmall")
	mgdminiText2:SetPoint("LEFT", mgdmini, "RIGHT", 5, -10)
    mgdminiText2:SetText("LDB Slidebar Icon and Titan Panel is Available")
    
   -- Add other options as we think of them --
    
    
